import 'dart:developer';

import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:hub/shared/components/molecules/locals/index.dart';
import 'package:hub/shared/components/molecules/modules/index.dart';
import 'package:rxdart/rxdart.dart';

class LocalsRepositoryImpl implements LocalsRepository {
  final LocalsRemoteDataSource remoteDataSource = LocalsRemoteDataSourceImpl();

  static final license = BehaviorSubject<LicenseStatus>();
  static get stream => license.stream;

  @override
  Future<void> validateLocal(BuildContext context) async {
    return await remoteDataSource.checkLocals(context);
  }

  @override
  Future<bool> update(BuildContext context) async {
    // LocalsRepositoryImpl.license.add(false);
    final bool response = await remoteDataSource.processLocals(context);
    context.read<LocalProfileBloc>().add(LocalProfileEvent());
    // LocalsRepositoryImpl.license.add(response);
    return response;
  }

  @override
  Future<void> unlinkLocal(BuildContext context) {
    return remoteDataSource.detachLocal(context);
  }
}
